master:
  image: python:3.9
  script:
    - apt-get update -qy
    - >
      apt-get install -qy
      libopenblas-dev libscalapack-mpi-dev libxc-dev > apt-get.output
    - python -m venv ../venv
    - source ../venv/bin/activate
    - pip install -U pip
    - pip install flake8 mypy pytest interrogate
    - pip -q install git+https://gitlab.com/ase/ase.git@master
    - pip -q install git+https://gitlab.com/myqueue/myqueue.git@master
    - >
      echo "scalapack = True;
      libraries += ['scalapack-openmpi'];
      extra_compile_args += ['-Werror', '-fopenmp'];
      extra_link_args += ['-fopenmp']
      " > siteconfig.py
    - pip install -e .
    - gpaw install-data --register pawdata
    - gpaw test
    - OMP_NUM_THREADS=2 pytest -v -m ci -We
    - mypy -p gpaw
    - >
      interrogate -m -i -f 34.1
      -e gpaw/test
      -e gpaw/point_groups/groups.py
      gpaw
    - flake8 --doctests gpaw
    - >
      flake8
      --doctests
      --exclude "doc/platforms/*,doc/*/summerschool18/*/*"
      --extend-ignore E402
      doc
    - python -We:invalid -m compileall -f -q gpaw/
    # - echo "parallel_python_interpreter = True" >> ~/.gpaw/siteconfig.py
    # - echo "libraries += ['blas']" >> ~/.gpaw/siteconfig.py
    # - python setup.py install > gpaw-python-install.output
    # - su user -c 'gpaw-python -m gpaw info'
    - mq config --in-place
    - mq init
    - mq workflow -p agts.py -zT | tail -1 | tee count
    - python -c "assert int(open('count').read().split()[0]) >= 422"
    - python -c "import pathlib; assert len(list(pathlib.Path().glob('**/*.png'))) <= 6"

libxc:
  image: python:3.7
  script:
    - git clone https://gitlab.com/libxc/libxc.git
    - cd libxc
    - git checkout 5.1.7
    - autoreconf -i
    - ./configure --enable-shared --disable-fortran --prefix=$HOME/libxc
    - make > libxc-install.out
    - make install
    - cd ..
    - pip install pytest ase
    - >
      echo "noblas = True;
      libraries = ['xc'];
      xc = Path.home() / 'libxc';
      lib = xc / 'lib';
      library_dirs = [lib];
      include_dirs = [xc / 'include'];
      extra_link_args = [f'-Wl,-rpath={lib}']
      " > siteconfig.py
    - pip install -e .
    - gpaw install-data --register gpaw-datasets
    - pytest -m libxc -x
  when: manual

docs:
  image: python:3.9
  script:
    - python3 -m venv venv
    - source venv/bin/activate
    - pip install sphinx-rtd-theme pytest
    - echo "noblas = True; nolibxc = True" > siteconfig.py
    - pip install -e .
    - tools/gpaw-setup H C O Li
    - export GPAW_SETUP_PATH=$PWD
    - cd doc
    - make
    - make doctest
  when: manual
  artifacts:
    paths:
      - doc/build/html
